﻿using SFML.Graphics;
using SFML.Window;
using System;

//====================================================
// Описание работы классов и методов исходника на:
// www.interestprograms.ru
// Исходные коды программ и игр
// Автор исходных кодов Клочков Павел
//====================================================

namespace sfml4
{
    class Window2D : RenderWindow
    {
        // Составляющие заднего фона окна рендеринга
        private readonly Texture texture;
        private readonly Sprite background;

        // Необходимые настройки формируем в конструкторе без параметров
        public Window2D() : base(new VideoMode(800, 600, 24), "Космический стражник")
        {
            texture = new Texture(Resource.bg);
            background = new SFML.Graphics.Sprite(texture);

            // Ограничение частоты фреймов для стабилизации скорости 
            // рендеринга сюжета игры
            base.SetFramerateLimit(80);

            base.Resized += Window2D_Resized;
            base.Closed += Window2D_Closed;
        }

        private void Window2D_Closed(object sender, EventArgs e)
        {
            base.Close();
        }

        private void Window2D_Resized(object sender, SizeEventArgs e)
        {
            // Вычисление вектора масштабирования для спрайта заднего фона
            float i = (float)Convert.ToDouble(e.Width);
            float j = (float)Convert.ToDouble(e.Height);
            float x = i / background.GetLocalBounds().Width;
            float y = j / background.GetLocalBounds().Height;

            // Масштабируем размеры фона под новый размер окна
            background.Scale = new SFML.System.Vector2f(x, y);



            // Размер угла просмотра (камеры) также подстраиваем 
            // под новые размеры окна приложения.
            // Необходимо для корректировки координат объектов.
            var view = new View(new FloatRect(0, 0, e.Width, e.Height));
            base.SetView(view);
        }

        public void DrawBG()
        {
            base.Draw(background);
        }
    }
}
